#include "common/meta.hpp"
#include "nodes/base/base.hpp"

namespace GNode
{

BaseNode::BaseNode(const std::string& name, NODE_TYPE type)
{
    name_ = name;
    type_ = type;
}

BaseNode::~BaseNode()
{

}

void BaseNode::start()
{
    if (!running_.exchange(true))
    {
        worker_thread_ = std::thread(&BaseNode::work, this);
    }
}

void BaseNode::stop()
{
    if (running_.exchange(false))
    {
        cond_var_->notify_all();
        if (worker_thread_.joinable())
        {
            worker_thread_.join();
        }
        PLOGI.printf("Node : [%s] stopped", name_.c_str());
    }
}

} // namespace Node